# TODO: cmdir: (req: extra hw driver, http://www.innovationone.ca/)

# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool sh %{SOURCE10}
# end stuff to be ...

# temporarily hardcoded:
%define kver      2.6.16-1.ML5.2
%ifnarch i686 x86_64 ppc
%define kvariants ""
%else
%ifarch i686
%define kvariants "" smp xen0 xenU
%endif
%ifarch x86_64
%define kvariants "" xen0 xenU
%endif
%ifarch ppc
%define kvariants "" smp
%endif
%endif

                %define kmod_name lirc
                %define kverrel   %(%{kmodtool} verrel  %{?kver} 2>/dev/null)
%{!?kvariants:  %global kvariants %(%{kmodtool} variant %{?kver} 2>/dev/null)}

Name:           %{kmod_name}-kmod
Version:        0.8.0
Release:        3.%(echo %{kverrel} | tr - _)
Summary:        LIRC kernel modules

Group:          System Environment/Kernel
License:        GPL
URL:            http://www.lirc.org/
Source0:        http://download.sf.net/lirc/%{kmod_name}-%{version}.tar.bz2
Patch0:         %{name}-0.8.0pre2-gpio-no-bttvp.patch
Patch1:         %{name}-0.8.0-2616.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i586 i686 x86_64 ppc

%description
LIRC is a package that allows you to decode and send infra-red and
other signals of many (but not all) commonly used remote controls.
Included applications include daemons which decode the received
signals as well as user space applications which allow controlling a
computer with a remote control.  This package contains additional
kernel modules to support additional remote control units.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5

%setup -q -c -T -a 0
cd lirc-%{version}*
%patch0 -p0
%patch1 -p0
# *cough*
echo %{kverrel} | grep -q _FC5 && sed -i s/2,6,16/2,6,15/ \
    drivers/lirc_{i2c,imon,sasem,streamzap,*usb*}/lirc_*.c
# http://sf.net/tracker/?func=detail&aid=1406110&group_id=5444&atid=105444
sed -i -e 's/<asm\/segment\.h>/<asm\/uaccess.h>/' drivers/lirc_*/lirc_*.c
cd ..
for kvariant in %{kvariants} ; do
    cp -a lirc-%{version}* _kmod_build_$kvariant
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}

    cd _kmod_build_$kvariant

    # cmdir: unknown symbols (cmdir_{read,write}, set_tx_channels), needs
    # additional hw driver from http://www.innovationone.ca/
    nobuild="cmdir"
    # gpio: missing drivers/media/video/bttv.h in kernel-devel
    [ -e $ksrc/drivers/media/video/bttv.h ] || nobuild="$nobuild gpio"
    # parallel: not smp safe
    grep -q ^CONFIG_SMP=y $ksrc/.config && nobuild="$nobuild parallel"
    for drv in $nobuild ; do
        sed -i -e "s/^\\s*(lirc_dev lirc_$drv)//" -e "s/^\\s*lirc_$drv//" \
            configure*
    done
    touch -r aclocal.m4 configure.in # avoid autofoo re-run

    %configure \
        --enable-sandboxed \
        --with-kerneldir=$ksrc \
        --with-moduledir=/lib/modules/%{kverrel}$kvariant/extra/%{kmod_name} \
        --with-driver=all
    make %{?_smp_mflags} -C drivers

    cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for dir in _kmod_build_* ; do
    make -C $dir/drivers install DESTDIR=$RPM_BUILD_ROOT
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Sun May 20 2007 Eddy Nigg <eddy_nigg@startcom.org>
- Update for kernel

* Mon Apr 03 2006 Eddy Nigg <eddy_nigg@startcom.org>
- Rebuild for StartCom Linux 5.0.x

* Mon Mar 13 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-3
- Hardcode kernel version and variants for test builds.
- Remove xen-hypervisor and xen-guest from kmodtool.

* Sat Jan 28 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-2
- Update kmodtool to 0.10.4, fixes support for non-UP FC kernels.

* Sat Jan 21 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-1
- 0.8.0.
- Hopefully fix lirc_{it87,serial,sir} on PPC, thanks to upstream.
- Hopefully fix i2c and usb drivers with kernel >= 2.6.15.
- Remove "up" == "" support, related cleanups.

* Tue Jan 17 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.9.pre4
- Add RHEL4 compatibility.

* Sat Jan 14 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.8.pre4
- 0.8.0pre4.
- Build all variants in separate dirs again for proper -debuginfo reasons.

* Sun Jan  8 2006 Thorsten Leemhuis <fedora at leemhuis.info> - 0.8.0-0.7.pre3
- Experiment with a new fedora-kmodhelper
- use a different approach for extracting/build/install

* Wed Jan  4 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.6.pre3
- Drop 2.6.15pre support hack.
- Clean up unneeded kernel-devel build dependency.

* Sun Jan  1 2006 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.5.pre3
- 0.8.0pre3.

* Wed Dec 28 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.5.pre2
- Build non-UP modules against the correct source tree, D'oh!
- Patch gpio driver to not require bttvp.h (private), build and ship it
  if bttv.h is in kernel-devel.
- Disable parallel driver with SMP.

* Wed Dec 28 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.4.pre2
- s/kmod-config(lirc)/lirc-kmod-common/

* Tue Dec 27 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.8.0-0.3.pre2
- Split from the main lirc package, adapt to new kmod standard.
- Disable debugging features.
